//---------------------------------------------------------------------------
#include "AB.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void Odcinki::Porzadkuj()
{
  for (int i=0; i<ile; i++)
	o[i].Porzadkuj();
}
//---------------------------------------------------------------------------
istream& operator>>(istream& is, Odcinki &o)
{
  delete[] o.o;
  o.o = new Odcinek[o.ile];
  for (int i=0; i<o.ile; i++)
	is >> o[i].a >> o[i].b;
  return is;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void Sasiedzi::Usun()
{
  delete[] ileS; ileS = 0;
  for (int i=0; i<ile; i++)
	delete[] s[i];
  delete[] s; s = 0;
  ile = 0;
}
//---------------------------------------------------------------------------
void Sasiedzi::Wyznacz(int n, Odcinki &o)
{
  Usun();
  ile = n;
  ileS = new int[ile];
  memset(ileS, 0, ile*sizeof(*ileS));
  for (int i=0; i<o.ile; i++)
	ileS[o[i].a-1]++, ileS[o[i].b-1]++;
  s = new int*[ile];
  for (int i=0; i<ile; i++)
	s[i] = new int[ileS[i]];
  memset(ileS, 0, ile*sizeof(*ileS));
  for (int i=0; i<o.ile; i++)
  {
	s[o[i].a-1][ileS[o[i].a-1]] = o[i].b;
	s[o[i].b-1][ileS[o[i].b-1]] = o[i].a;
	ileS[o[i].a-1]++, ileS[o[i].b-1]++;
  }
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
ZadanieAB::~ZadanieAB()
{
  delete[] numer;
  delete[] sasiad;
  delete[] poz;
}
//---------------------------------------------------------------------------
void ZadanieAB::Start()
{
  delete[] numer; numer = new int[n];
  delete[] sasiad; sasiad = new int[n];
  delete[] poz; poz = new int[n];
  memset(poz, 0, n*sizeof(*poz));
  ileWyzn = 0;
}
//---------------------------------------------------------------------------
void ZadanieAB::Dodaj(int i)
{
  numer[ileWyzn] = i;
  sasiad[ileWyzn] = -1;
  poz[i-1] = ++ileWyzn;
}
//---------------------------------------------------------------------------
void ZadanieAB::Zdejmij()
{
  ileWyzn--;
  poz[numer[ileWyzn]-1] = 0;
  sasiad[ileWyzn-1]++;
}
//---------------------------------------------------------------------------
bool ZadanieAB::Naprzod()
{
  // Pocztek
  if (!ileWyzn)
  {
	Dodaj(1);
	return true;
  }

  // Prbujemy dooy nastpnego
  if (ileWyzn < n)
  {
	int biezacy = numer[ileWyzn-1]-1;
	for (int i=sasiad[ileWyzn-1]+1; i<s.IleS(biezacy); i++)
	  if (!poz[s[biezacy][i]-1])
	  {
		Dodaj(s[biezacy][i]);
		return true;
	  }
  }

  // Prbujemy zmieni biecego
  if (ileWyzn > 1)
  {
	Zdejmij();
	Naprzod();
  }

  // nic si nie udao
  return false;
}
//---------------------------------------------------------------------------
bool ZadanieAB::Wstecz()
{
  if (ileWyzn < 2) return false;
  Zdejmij();
  return true;
}
//---------------------------------------------------------------------------
bool ZadanieAB::JedenKrok()
{
  if (Naprzod()) return true;
  do
	if (!Wstecz()) return false;
  while (!Naprzod());
  return true;
}
//---------------------------------------------------------------------------
bool ZadanieAB::ZamykaSie()
{
  int last = numer[n-1];
  for (int i=0; i<s.IleS(0); i++)
	if (s[0][i] == last)
	  return true;
  return false;
}
//---------------------------------------------------------------------------
bool ZadanieAB::NieMaPrzeciec()
{
  int a1, b1, a2, b2;
  for (int i=0; i<o.ile; i++)
  {
	a1 = poz[o[i].a-1];
	b1 = poz[o[i].b-1];
	for (int j=i+1; j<o.ile; j++)
	{
	  a2 = poz[o[j].a-1];
	  b2 = poz[o[j].b-1];
	  if (a1 < a2 && b1 > a2 && b1 < b2 ||
		  a2 < a1 && b2 > a1 && b2 < b1)
		return false;
	}
  }
  return true;
}
//---------------------------------------------------------------------------
bool ZadanieAB::Rozwiaz()
{
  o.Porzadkuj();
  s.Wyznacz(n,o);
  Start();
  while (1)
  {
	if (!JedenKrok())
	  return sukces = false;
	if (ileWyzn == n && ZamykaSie() && NieMaPrzeciec())
	  return sukces = true;
  }
}
//---------------------------------------------------------------------------
istream& operator>>(istream& is, ZadanieAB &ab)
{
  is >> ab.n >> ab.m;
  ab.o.ile = ab.n + ab.m;
  is >> ab.o;
  return is;
}
//---------------------------------------------------------------------------
ostream& operator<<(ostream& os, const ZadanieAB &ab)
{
  os << "1 ";
  if (ab.numer[1] < ab.numer[ab.n-1])
	for (int i=1; i<ab.n; i++)
	  os << ab.numer[i] << " ";
  else
	for (int i=ab.n; --i; )
	  os << ab.numer[i] << " ";
  return os;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

